#include<stdio.h>
#include<string.h>

class K
{
public:
  K(const char *art);
  virtual ~K();
  virtual void m();

protected:
  char string[256];
};

K::K(const char *art)
{
   strcpy(string,art);
   printf("K::K: %s\n",art); 
}

K::~K()
{
   printf("K::~K: %s\n",string); 
}

void K::m()
{
  printf("K::m\n");
}

class UK : public K
{
public:
  UK(const char *art):K(art) { printf("UK::UK\n"); }
  virtual void m();
  virtual ~UK();  
};

UK::~UK()
{
  printf("UK::~UK\n");
}

void UK::m() 
{
  printf("UK::m() %s\n",string);
}
 
K sk("static");
int main(int argc,char **arg)
{
  UK auk("auto");
  K *kp=&auk;
  kp->m();
}
